#include "testlib.h"

#include <string>
#include <vector>

using namespace std;

typedef long long ll;

const ll MAX_N = 200'000;
const ll MAX_R = 1'000'000'000;
const ll MAX_V = 1'000'000'000;
const ll MAX_X = 1'000'000'000;


int getAns(InStream &stream, int n, int x, int m, vector<int> a) {
    int len = stream.readInt(-1, n);
    if (len == -1) {
        return -1;
    }
    vector<int> lol;
    for (int i = 0; i < len; i++) {
        int ind = stream.readInt(1, n);
        lol.push_back(ind);
        stream.ensuref(x + ind - 1 <= n, "last has problem %d > %d", x + ind - 1, n);
    }
    std::sort(lol.begin(), lol.end());
    for (int i = 0; i < len - 1; i++) {
        stream.ensuref(lol[i] + x <= lol[i + 1], "intersection");
    }
    for (int i = 0; i < n; i++) {
        if (a[i] > m) {
            auto it = (int)(std::upper_bound(lol.begin(), lol.end(), i + 1) - lol.begin()) - 1;
            stream.ensuref(it >= 0, "it < 0, %d", i + 1);
            stream.ensuref(lol[it] + x - 1 >= i + 1 && lol[it] <= i + 1, "no cover %d > %d", lol[it] + x - 1, i + 1);
        }
    }
    return len;
}

int main(int argc, char *argv[])
{
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int x = inf.readInt();
    int m = inf.readInt();
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt();
    }
    ll pa = getAns(ouf, n, x, m, a);
    ll ja = getAns(ans, n, x, m, a);
    if (pa == -1 && ja != -1) {
        quitf(_wa, "pa (%lld) != ja (%lld)", pa, ja);
    }
    if (pa != -1 && ja == -1) {
        quitf(_fail, "pa (%lld) != ja (%lld)", pa, ja);
    }
    if (pa > ja) {
        quitf(_wa, "pa (%lld) > ja (%lld)", pa, ja);
    } else if (pa < ja) {
        quitf(_fail, "pa (%lld) < ja (%lld)", pa, ja);
    } else {
        quitf(_ok, "OK");
    }

    return 0;
}

