#include "testlib.h"

#include <string>
#include <vector>

using namespace std;

typedef long long ll;

const ll MAX_N = 200'000;
const ll MAX_R = 1'000'000'000;
const ll MAX_V = 1'000'000'000;
const ll MAX_X = 1'000'000'000;

vector<int> tree;

void upd(int v, int l, int r, int pos, int val) {
    if (l == r - 1) {
        tree[v] = max(tree[v], val);
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        upd(v * 2, l, m, pos, val);
    } else {
        upd(v * 2 + 1, m, r, pos, val);
    }
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (ql >= r || qr <= l) {
        return 0;
    }
    int m = (l + r) / 2;
    return max(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
}

int getAns(InStream &stream, int n, int x, vector<pair<int, int>> a) {
    ll ansS = stream.readLong(1, MAX_N + 1, "ans");
    ll r = stream.readLong(1, MAX_R, "r");
    ll v = stream.readLong(1, MAX_V, "v");
    a.emplace_back(r, v);
    std::sort(a.begin(), a.end());
    n = (int)a.size();
    tree.assign(4 * n, 0);
    set<int> s;
    for (auto i : a) {
        s.insert(i.second);
    }
    map<int, int> mp;
    for (int i : s) {
        mp[i] = (int)mp.size();
    }
    mp[MAX_V + 1] = n;
    int answ = 0;
    for (int i = 0; i < n; i++) {
        // v_j <= v_i <= v_j + x
        int ql = mp.lower_bound(a[i].second - x)->second;
        auto it = mp.upper_bound(a[i].second);
        int qr = it->second;
        answ = max(get(1, 0, n, ql, qr) + 1, answ);
        upd(1, 0, n, mp[a[i].second], get(1, 0, n, ql, qr) + 1);
    }
    if (ansS != answ) {
        stream.quitf(_wa, "a (%lld) != realAns (%d)", ansS, answ);
    }
    return answ;
}

int main(int argc, char *argv[])
{
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int x = inf.readInt();
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        a[i].first = inf.readInt();
        a[i].second = inf.readInt();
    }
    //a = {{1, 2}, {2, 5}, {4, 11}};
    ll pa = getAns(ouf, n, x, a);
    ll ja = getAns(ans, n, x, a);
    if (pa < ja) {
        quitf(_wa, "pa (%lld) < ja (%lld)", pa, ja);
    } else if (pa > ja) {
        quitf(_fail, "pa (%lld) > ja (%lld)", pa, ja);
    } else {
        quitf(_ok, "OK");
    }

    return 0;
}

