//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n;
  ll x;
  cin >> n >> x;
  vector<pair<ll, ll>> a(n);
  vector<ll> pb;
  for (int i = 0; i < n; ++i) {
    cin >> a[i].first >> a[i].second;
    pb.push_back(a[i].second);
  }
  sort(pb.begin(), pb.end());
  pb.erase(unique(pb.begin(), pb.end()), pb.end());
  auto getid = [&](ll y) {
    return int(lower_bound(pb.begin(), pb.end(), y) - pb.begin());
  };
  sort(a.begin(), a.end());
  int nb = int(pb.size());
  int pw = 1;
  while (pw < nb) pw *= 2;
  vector<pair<int, int>> tree(2 * pw);

  auto Get = [&](ll L, ll R) {
    int ql = getid(L);
    int qr = getid(R);
    pair<int, int> res{0, -1};
    for (ql += pw, qr += pw; ql < qr; ql /= 2, qr /= 2) {
      if (ql & 1) {
        smax(res, tree[ql++]);
      }
      if (qr & 1) {
        smax(res, tree[--qr]);
      }
    }
    return res;
  };
  auto Upd = [&](ll at, int val) {
    int i = getid(at);
    tree[i + pw].second = i;
    for (smax(tree[i += pw].first, val); i /= 2; ) {
      tree[i] = max(tree[2 * i], tree[2 * i + 1]);
    }
  };

  int ans = 0;
  ll ansa = -1;
  ll ansb = -1;
  vector<pair<int, int>> forSuffix(n);
  for (int i = 0; i < n; ++i) {
    int mdp = Get(a[i].second - x, a[i].second + 1).first + 1;
    debug(i);
    debug(mdp);
    if (smax(ans, mdp + 1)) {
      ansa = a[i].first;
      ansb = a[i].second;
    }
    Upd(a[i].second, mdp);
    if (i + 1 < n) {
      forSuffix[i + 1] = Get(a[i + 1].second - 2 * x, a[i + 1].second + 1);
    }
  }
  fill(tree.begin(), tree.end(), make_pair(0, -1));
  for (int i = n - 1; i >= 0; --i) {
    int mdp = Get(a[i].second, a[i].second + x + 1).first + 1;
    debug(i);
    debug(mdp);
    debug(forSuffix[i].first);
    debug(forSuffix[i].second);
    if (smax(ans, mdp + 1)) {
      ansa = a[i].first;
      ansb = a[i].second;
    }
    if (smax(ans, mdp + 1 + forSuffix[i].first)) {
      ansa = a[i].first;
      ansb = (a[i].second + pb[forSuffix[i].second]) / 2;
    }
  }
  assert(ans > 0);
  cout << ans << ' ' << ansa << ' ' << ansb << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}