#include<iostream>
#include<vector>
#include<cmath>
#include<string>
#include<algorithm>
#include<set>
#include<queue>
#include<iomanip>
#include<map>

typedef long long ll;
typedef long double ld;
using namespace std;


const ll MAX_V = 1000000000;


vector<pair<int, int>> tree;

void upd(int v, int l, int r, int pos, int val) {
    if (l == r - 1) {
        tree[v] = {max(tree[v].first, val), pos};
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        upd(v * 2, l, m, pos, val);
    } else {
        upd(v * 2 + 1, m, r, pos, val);
    }
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

pair<int, int> get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (ql >= r || qr <= l) {
        return {0, -1};
    }
    int m = (l + r) / 2;
    return max(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, x;
    cin >> n >> x;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    tree.resize(4 *  n);
    vector<int> dp(n);
    std::sort(a.begin(), a.end());
    set<int> s;
    for (auto i : a) {
        s.insert(i.second);
    }
    map<int, int> mp, rmp;
    for (int i : s) {
        rmp[(int)mp.size()] = i;
        mp[i] = (int)mp.size();
    }
    mp[MAX_V + 1] = n;
    for (int i = 0; i < n; i++) {
        // v_j <= v_i <= v_j + x
        int ql = mp.lower_bound(a[i].second - x)->second;
        auto it = mp.upper_bound(a[i].second);
        int qr = it->second;
        dp[i] = get(1, 0, n, ql, qr).first + 1;
        upd(1, 0, n, mp[a[i].second], dp[i]);
    }
    tree.assign(4 *  n, {0, -1});
    int ansDp = 0, v = -1, r = -1;
    for (int i = n - 1; i >= 0; i--) {
        // v_i <= V <= v_i + x
        // V <= v_j < V + x
        int ql = mp.lower_bound(a[i].second)->second;
        auto it = mp.upper_bound(a[i].second + 2 * x);
        int qr = it->second;
        pair<int, int> right = get(1, 0, n, ql, qr);
        if (right.first + dp[i] + 1 > ansDp) {

            ansDp = right.first + dp[i] + 1;
            if (right.first == 0) {
                v = a[i].second;
            } else {
                v = (rmp[right.second] + a[i].second) / 2;
            }
            r = a[i].first;
        }
        ql = mp.lower_bound(a[i].second)->second;
        qr = mp.upper_bound(a[i].second + x)->second;
        upd(1, 0, n, mp[a[i].second], get(1, 0, n, ql, qr).first + 1);
    }
    cout << ansDp << ' ' << r << ' ' << v;
    return 0;
}