#include<iostream>
#include<vector>
#include<cmath>
#include<string>
#include<algorithm>
#include<set>
#include<queue>
#include<iomanip>
#include<map>

typedef long long ll;
typedef long double ld;
using namespace std;


const ll MAX_N = 200'000;
const ll MAX_R = 1'000'000'000;
const ll MAX_V = 1'000'000'000;
const ll MAX_X = 1'000'000'000;


vector<pair<int, int>> tree;

void upd(int v, int l, int r, int pos, int val) {
    if (l == r - 1) {
        tree[v] = {max(tree[v].first, val), pos};
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        upd(v * 2, l, m, pos, val);
    } else {
        upd(v * 2 + 1, m, r, pos, val);
    }
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

pair<int, int> get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (ql >= r || qr <= l) {
        return {0, -1};
    }
    int m = (l + r) / 2;
    return max(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, x;
    cin >> n >> x;
    vector<pair<int, int>> a(n);
    map<int, int> mp;
    ll ans = 1, r = 1, v = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        mp[a[i].second]++;
        if (ans < mp[a[i].first] + 1) {
            ans = mp[a[i].first] + 1;
            r = a[i].first;
            v = a[i].second;
        }
    }
    cout << ans << ' ' << r << ' ' << v;
    return 0;
}