#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int MAX_N = 1000'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int group = validator.group().empty() ? -1 : atoi(validator.group().c_str());

    int n = inf.readInt(2, MAX_N, "n");
    inf.readEoln();
    ensuref(n % 2 == 0, "n should be event");

    vector<char> s(n);
    for (int i = 0; i < n; ++i) {
        s[i] = inf.readChar();
        ensuref('a' <= s[i] && s[i] <= 'z', "symbols should be in a..z");
    }
    inf.readEoln();
    inf.readEof();

    vector<int> cs(26);
    for (int i = 0; i < n; ++i) {
        ++cs[s[i] - 'a'];
    }

    if (group == 1) {
        ensuref(n <= 10, "n should be <= 10 in g1");
    } else if (group == 2) {
        ensuref(cs[1] <= 2, "b must occur no more than 2 times in g2");
        ensuref(cs[0] + cs[1] == n, "no a and b symbols shouldn't occur in s in g2");
    } else if (group == 3) {
        ensuref(n <= 100, "n should be <= 100 in g3");
    } else if (group == 4) {
        ensuref(n <= 1000, "n should be <= 1000 in g4");
    } else if (group != 5 && group != 0) {
        ensuref(false, "unknown group %s", validator.group().c_str());
    }

    inf.readEof();

}