// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 1000100;
const int P = 239;
// const int P = 10;
const int MOD = (int)1e9 + 7;

template<int MOD>
class generic_mint {
public:
    static_assert(MOD > 1 && MOD < std::numeric_limits<int>::max() / 2);

    generic_mint() {
        value = 0;
    }

    generic_mint(int _value) {
        if (_value >= 0 && _value < MOD) {
            value = _value;
        } else {
            value = _value % MOD;
            if (value < 0) {
                value += MOD;
            }
        }
    }

    generic_mint(ll _value) {
        if (_value >= 0 && _value < MOD) {
            value = _value;
        } else {
            value = _value % MOD;
            if (value < 0) {
                value += MOD;
            }
        }
    }

    generic_mint(int _value, bool ignored) {
        assert(ignored);
        value = _value;
    }

    generic_mint(ll _value, bool ignored) {
        assert(ignored);
        value = _value;
    }

    generic_mint<MOD> operator+() const {
        return *this;
    }

    generic_mint<MOD> operator-() const {
        return generic_mint<MOD>(MOD - value, true);
    }

    generic_mint<MOD> operator+(const generic_mint<MOD>& other) const {
        if (value + other.value >= MOD) {
            return generic_mint<MOD>(value + other.value - MOD, true);
        }
        return generic_mint<MOD>(value + other.value, true);
    }

    generic_mint<MOD> operator-(const generic_mint<MOD>& other) const {
        if (value - other.value < 0) {
            return generic_mint<MOD>(value - other.value + MOD, true);
        }
        return generic_mint<MOD>(value - other.value, true);
    }

    generic_mint<MOD> operator*(const generic_mint<MOD>& other) const {
        return generic_mint<MOD>((int)(1ll * value * other.value % MOD), true);
    }

    generic_mint<MOD> operator/(const generic_mint<MOD>& other) const {
        return (*this) * other.pow(MOD - 2);
    }

    generic_mint<MOD>& operator+=(const generic_mint<MOD>& other) {
        *this = (*this) + other;
        return *this;
    }

    generic_mint<MOD>& operator-=(const generic_mint<MOD>& other) {
        *this = (*this) - other;
        return *this;
    }

    generic_mint<MOD>& operator*=(const generic_mint<MOD>& other) {
        *this = (*this) * other;
        return *this;
    }

    generic_mint<MOD>& operator/=(const generic_mint<MOD>& other) {
        *this = (*this) / other;
        return *this;
    }

    generic_mint<MOD> operator++(int) {
        auto result = *this;
        *this += generic_mint<MOD>(1, true);
        return result;
    }

    generic_mint<MOD>& operator++() {
        *this += generic_mint<MOD>(1, true);
        return *this;
    }

    generic_mint<MOD> operator--(int) {
        auto result = *this;
        *this -= generic_mint<MOD>(1, true);
        return result;
    }

    generic_mint<MOD>& operator--() {
        *this -= generic_mint<MOD>(1, true);
        return *this;
    }

    generic_mint<MOD> pow(ll n) const {
        assert(n >= 0);

        generic_mint<MOD> result(1, true);
        generic_mint<MOD> cur = *this;
        while (n != 0) {
            if (n % 2 == 1) {
                result *= cur;
            }
            cur *= cur;
            n /= 2;
        }

        return result;
    }

    generic_mint<MOD> inv() const {
        return pow(MOD - 2);
    }

    int get_value() const {
        return value;
    }

    explicit operator int() const {
        return value;
    }

    explicit operator ll() const {
        return value;
    }

    bool operator<(const generic_mint<MOD>& other) const {
        return value < other.value;
    }

private:
    int value;
};

using mint = generic_mint<MOD>;
using Hash = std::pair<mint, ull>;

Hash operator+(const Hash& a, const Hash& b) {
    return std::make_pair(a.first + b.first, a.second + b.second);
}

Hash operator-(const Hash& a, const Hash& b) {
    return std::make_pair(a.first - b.first, a.second - b.second);
}

Hash operator*(const Hash& a, const Hash& b) {
    return std::make_pair(a.first * b.first, a.second * b.second);
}

class Hasher {
public:
    std::vector<Hash> powers, hashes;

    const Hash BASE = std::make_pair(mint(P, true), P);

    explicit Hasher(const std::string& s) {
        powers.resize(s.size() + 1);
        hashes.resize(s.size());

        powers[0] = std::make_pair(mint(1, true), 1);
        for (int i = 1; i < (int)powers.size(); ++i) {
            powers[i] = powers[i - 1] * BASE;
        }

        hashes[0] = std::make_pair(mint(s[0] - 'a' + 1, true), s[0] - 'a' + 1);
        for (int i = 1; i < (int)s.size(); ++i) {
            hashes[i] = hashes[i - 1] * BASE + std::make_pair(mint(s[i] - 'a' + 1, true), s[i] - 'a' + 1);
        }
    }

    Hash get(int l, int r) {
        assert(r < (int)hashes.size());

        Hash res = hashes[r];
        if (l != 0) {
            res = res - hashes[l - 1] * powers[r - l + 1];
        }
        return res;
    }
};

int n;
char s[2 * N];

void run() {
    scanf("%d\n%s", &n, s);
    for (int i = 0; i < n; ++i) {
        s[i + n] = s[i];
    }

    std::string even, odd;
    for (int i = 0; i < 2 * n; i += 2) {
        even.push_back(s[i]);
        odd.push_back(s[i + 1]);
    }

    Hasher hashEven(even), hashOdd(odd);
    std::map<Hash, int> cntEven, cntOdd;
    for (int i = 0; i < n; ++i) {
        Hash curEven, curOdd;
        if (i % 2 == 0) {
            curEven = hashEven.get(i / 2, i / 2 + n / 2 - 1);
            curOdd = hashOdd.get(i / 2, i / 2 + n / 2 - 1);
        } else {
            curEven = hashOdd.get(i / 2, i / 2 + n / 2 - 1);
            curOdd = hashEven.get(i / 2 + 1, i / 2 + n / 2);
        }
        ++cntEven[curEven];
        ++cntOdd[curOdd];

        // debug(curEven.first.get_value());
        // debug(curEven.second);
        // debug(curOdd.first.get_value());
        // debug(curOdd.second);
    }

    ll ans = 1ll * n * n;
    std::set<std::pair<Hash, Hash>> setik;
    for (int i = 0; i < n; ++i) {
        Hash curEven, curOdd;
        if (i % 2 == 0) {
            curEven = hashEven.get(i / 2, i / 2 + n / 2 - 1);
            curOdd = hashOdd.get(i / 2, i / 2 + n / 2 - 1);
        } else {
            curEven = hashOdd.get(i / 2, i / 2 + n / 2 - 1);
            curOdd = hashEven.get(i / 2 + 1, i / 2 + n / 2);
        }

        if (setik.find(std::make_pair(curEven, curOdd)) != setik.end()) {
            continue;
        }
        setik.insert(std::make_pair(curEven, curOdd));
        ans -= 1ll * cntEven[curEven] * cntOdd[curOdd];
    }

    printf("%lld\n", ans);
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    #ifdef PERVEEVM_LOCAL
        auto start = std::chrono::high_resolution_clock::now();
    #endif

    run();

    #ifdef PERVEEVM_LOCAL
        auto end = std::chrono::high_resolution_clock::now();
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
