//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

template <class T>
vector<int> pfunc(T const& s) {
  int n = (int) s.size();
  vector<int> p(n + 1);
  p[0] = -1;
  int k = -1;
  for (int i = 0; i < n; ++i) {
    while (k >= 0 && s[i] != s[k]) {
      k = p[k];
    }
    p[i + 1] = ++k;
  }
  return p;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n; cin >> n;
  string s; cin >> s;
  vector<int> g(2, 1);
  for (int i = 0; i < n; ++i) {
    g[i % 2] &= (s[i] == s[i % 2]);
  }

  if (g[0] & g[1]) {
    if (s[0] == s[1]) {
      cout << 0 << '\n';  
    } else {
      cout << ll(n) * n / 2 << '\n';
    }
    return 0;
  }

  ll ans = ll(n) * n;
  int per = n - pfunc(s).back();
  if (n % per != 0) {
    per = n;
  }
  ans -= per * ll(n / per) * ll(n / per);
  for (int rem = 0; rem < 2; ++rem) {
    if (g[rem]) {
      string t;
      for (int j = (rem ^ 1); j < n; j += 2) {
        t.push_back(s[j]);
      }
      int pert = n / 2 - pfunc(t).back();
      ans -= ll(n / 2) * (n / 2);
      if ((n / 2) % pert != 0) {
        pert = n / 2;
      }
      ans += pert * ll(n / 2 / (pert)) * (n / 2 / (pert));
    }
  }
  cout << ans << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}