#include "testlib.h"

using namespace std;
using pii = pair<int, int>;
const int MAX_FIELD_SIZE = 100000;

// argv:
// . . N_MAX M_MAX K_MAX REEF_PERCENT REEF_LIMIT
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = stoi(argv[2]);
    int m = min(stoi(argv[3]), MAX_FIELD_SIZE / n);
    int k = min(min(n, m), stoi(argv[4]));

    cout << n << ' ' << m << ' ' << k << '\n';

    vector<vector<char>> field(n);
    for (int i = 0; i < n; i++) {
        field[i].assign(m, '#');
    }

    for (int i = 0; i < k; i++) {
        field[i][0] = field[0][i] = '.';
    }

    int stor = rnd.next(0, 1);
    vector<int> mxc = {n, m};
    vector<int> cur = vector<vector<int>>{{k - 1, 0}, {0, k - 1}}[stor];
    int points_back = k;
    int cur_or = stor;
    while (cur != vector<int>{n - 1, m - 1}) {
        bool can_rotate = (points_back >= k);
        if (cur[cur_or] < mxc[cur_or] - 1 && (!can_rotate || rnd.next(0, 1))) {
            cur[cur_or]++;
            field[cur[0]][cur[1]] = '.';
            ++points_back;
            continue;
        }
        for (int i = 0; i < k; i++) {
            if (cur_or == 0) {
                field[cur[0]][min(cur[1] + i, m - 1)] = '.';
            } else {
                field[min(cur[0] + i, n - 1)][cur[1]] = '.';
            }
        }
        if (cur_or == 0) {
            cur[1] = min(cur[1] + k - 1, m - 1);
        } else {
            cur[0] = min(cur[0] + k - 1, n - 1);
        }
        cur_or = !cur_or;
        points_back = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << field[i][j];
        }
        cout << '\n';
    }
}