//#include "../testlib/testlib.h"
#include "testlib.h"

using namespace std;
const int MAX_N_M = 1000;
const int MAX_K = 1000;
const int MAX_FIELD_SIZE = 100'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int group = validator.group().empty() ? -1 : atoi(validator.group().c_str());

    int n = inf.readInt(1, MAX_N_M, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAX_N_M, "m");
    inf.readSpace();
    int k = inf.readInt(1, min(min(n, m), MAX_K), "k");
    inf.readEoln();

    ensuref(n * 1ll * m <= (long long) MAX_FIELD_SIZE, "Field size exceeds max");

    int rcnt = 0;
    for (int i = 0; i < n; i++) {
        string s = inf.readToken("[\.#]*", "field_i");
        inf.readEoln();
        ensuref(s.size() == m, "Field row length is not equal to m");
        for (char c : s) {
            rcnt += c == '#';
        }
    }

    inf.readEof();

    if (group == 1) {
        ensuref(n <= 5, "n should be <= 5 in g1");
        ensuref(m <= 5, "m should be <= 5 in g1");
    } else if (group == 2) {
        ensuref(rcnt <= 1, "should be no more 1 # in g2");
    } else if (group == 3) {
        ensuref(n <= 2, "n should be <= 2 in g3");
    } else if (group == 4) {
        ensuref(k == 1, "k should be == 1 in g4");
    } else if (group == 5) {
        ensuref(k <= 5, "k should be <= 5 in g5");
    }
}