/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, n, m, k)
    vector<string> field(n);
    cin >> field;
    vector<vector<int>> right(n, vector<int>(m)), down(n, vector<int>(m));
    for (int i = n - 1; i > -1; i--) {
        for (int j = m - 1; j > -1; j--) {
            if (field[i][j] == '#') {
                right[i][j] = down[i][j] = 0;
            } else {
                right[i][j] = 1 + (j + 1 < m ? right[i][j + 1] : 0);
                down[i][j] = 1 + (i + 1 < n ? down[i + 1][j] : 0);
            }
        }
    }

    vector<int> const dx{1, 0, -1, 0};
    vector<int> const dy{0, -1, 0, 1};

    int const S = n * m * 4;
    typedef tuple<int, int, int> loc;
    auto index = [&](int i, int j, int dir) {
        return (i * m + j) * 4 + dir;
    };
    auto ok = [&](int i, int j) {
        return 0 <= i && i < n && 0 <= j && j < m && field[i][j] == '.';
    };

    vector<int> dist(S, -1);
    deque<loc> q;
    if (right[0][0] >= k) {
        dist[0] = 0;
        q.push_back({0, 0, 0});
    }
    if (down[0][0] >= k) {
        dist[3] = 0;
        q.push_back({0, 0, 3});
    }
    while (!q.empty()) {
        auto [i, j, dir] = q.front();
        q.pop_front();
        int start_pos = index(i, j, dir);

        vector<loc> next;
        if (ok(i + dy[dir] * k, j + dx[dir] * k))
            next.emplace_back(i + dy[dir], j + dx[dir], dir);
        if (ok(i - dy[dir], j - dx[dir]))
            next.emplace_back(i - dy[dir], j - dx[dir], dir);

        for (int ddir = -1; ddir <= 1; ddir += 2) {
            int ndir = (dir + ddir + 4) % 4;
            int hi = i + dy[dir] * (k - 1), hj = j + dx[dir] * (k - 1);
            int ti = hi + dy[ndir] * (k - 1), tj = hj + dx[ndir] * (k - 1);
            if (ok(ti, tj) &&
                (dy[ndir] == 0 && right[hi][min(hj, tj)] >= k || dx[ndir] == 0 && down[min(hi, ti)][hj] >= k))
                next.emplace_back(hi, hj, ndir);
        }

        for (auto &l : next) {
            auto [ni, nj, ndir] = l;
            int pos = index(ni, nj, ndir);
            if (dist[pos] == -1) {
                dist[pos] = dist[start_pos] + 1;
                q.push_back(l);
            }
        }
    }

    int p1 = index(n - 1, m - k, 0);
    int p2 = index(n - k, m - 1, 3);
    int d1 = dist[p1] == -1 ? S : dist[p1], d2 = dist[p2] == -1 ? S : dist[p2];
    int d = min(d1, d2);
    cout << (d < S ? d : -1) << '\n';

}